commit 01494d245d8c197788c34c96e4af62ab1a9e7ed1
Author: freddy77 <freddy77>
Date:   Tue Mar 2 15:07:00 2010 +0000

    add ReadError and reuse it

diff --git a/ChangeLog b/ChangeLog
index a09665d..ca587e0 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,10 @@
+Tue Mar  2 16:06:34 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/common.c src/odbc/unittests/common.h:
+	* src/odbc/unittests/error.c src/odbc/unittests/getdata.c:
+	* src/odbc/unittests/paramcore.c src/odbc/unittests/print.c:
+	* src/odbc/unittests/rowset.c src/odbc/unittests/transaction2.c:
+	- add ReadError and reuse it
+
 Tue Mar  2 09:32:02 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/util.c:
 	- remove last exit calls (original patch from David Dick)
@@ -2345,4 +2352,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2996 2010/03/02 08:32:36 freddy77 Exp $
+$Id: ChangeLog,v 1.2997 2010/03/02 15:07:00 freddy77 Exp $
diff --git a/src/odbc/unittests/common.c b/src/odbc/unittests/common.c
index cb75715..a2f7f70 100644
--- a/src/odbc/unittests/common.c
+++ b/src/odbc/unittests/common.c
@@ -12,7 +12,7 @@
 #define TDS_SDIR_SEPARATOR "\\"
 #endif
 
-static char software_version[] = "$Id: common.c,v 1.56 2010/01/10 14:43:11 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.57 2010/03/02 15:07:00 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 HENV Environment;
@@ -441,3 +441,15 @@ CommandProc(HSTMT stmt, const char *command, const char *file, int line, const c
 	return CheckRes(file, line, SQLExecDirect(stmt, (SQLCHAR *) command, SQL_NTS), SQL_HANDLE_STMT, stmt, "Command", res);
 }
 
+char odbc_err[512];
+char odbc_sqlstate[6];
+
+void
+ReadError(void)
+{
+	memset(odbc_err, 0, sizeof(odbc_err));
+	memset(odbc_sqlstate, 0, sizeof(odbc_sqlstate));
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, (SQLCHAR *) odbc_sqlstate, NULL, (SQLCHAR *) odbc_err, sizeof(odbc_err), NULL, "SI");
+	printf("Message: '%s' %s\n", odbc_sqlstate, odbc_err);
+}
+
diff --git a/src/odbc/unittests/common.h b/src/odbc/unittests/common.h
index 22382b7..8c449cd 100644
--- a/src/odbc/unittests/common.h
+++ b/src/odbc/unittests/common.h
@@ -21,7 +21,7 @@
 #include <sql.h>
 #include <sqlext.h>
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.30 2010/01/10 14:43:11 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.31 2010/03/02 15:07:00 freddy77 Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #ifndef HAVE_SQLLEN
@@ -38,6 +38,9 @@ extern HDBC Connection;
 extern HSTMT Statement;
 extern int use_odbc_version3;
 extern void (*odbc_set_conn_attr)(void);
+extern char odbc_err[512];
+extern char odbc_sqlstate[6];
+
 
 extern char USER[512];
 extern char SERVER[512];
@@ -47,6 +50,8 @@ extern char DRIVER[1024];
 
 int read_login_info(void);
 void ReportError(const char *msg, int line, const char *file);
+void ReadError(void);
+
 
 void CheckCols(int n, int line, const char * file);
 void CheckRows(int n, int line, const char * file);
diff --git a/src/odbc/unittests/error.c b/src/odbc/unittests/error.c
index f7d8e76..5a8785d 100644
--- a/src/odbc/unittests/error.c
+++ b/src/odbc/unittests/error.c
@@ -2,19 +2,9 @@
 
 /* some tests on error reporting */
 
-static char software_version[] = "$Id: error.c,v 1.9 2008/12/03 12:55:52 freddy77 Exp $";
+static char software_version[] = "$Id: error.c,v 1.10 2010/03/02 15:07:00 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-static SQLCHAR output[256];
-static void ReadError(void);
-
-static void
-ReadError(void)
-{
-	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, NULL, NULL, output, sizeof(output), NULL, "SI");
-	printf("Message: %s\n", output);
-}
-
 int
 main(int argc, char *argv[])
 {
@@ -44,7 +34,7 @@ main(int argc, char *argv[])
 	}
 
 	ReadError();
-	if (!strstr((char *) output, "zero")) {
+	if (!strstr(odbc_err, "zero")) {
 		fprintf(stderr, "Message invalid\n");
 		return 1;
 	}
diff --git a/src/odbc/unittests/getdata.c b/src/odbc/unittests/getdata.c
index 032a73a..b9b2daa 100644
--- a/src/odbc/unittests/getdata.c
+++ b/src/odbc/unittests/getdata.c
@@ -1,22 +1,9 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: getdata.c,v 1.16 2009/12/28 13:30:31 freddy77 Exp $";
+static char software_version[] = "$Id: getdata.c,v 1.17 2010/03/02 15:07:00 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-static char odbc_err[256];
-static char odbc_sqlstate[6];
-
-static void
-ReadError(void)
-{
-	memset(odbc_err, 0, sizeof(odbc_err));
-	memset(odbc_sqlstate, 0, sizeof(odbc_sqlstate));
-	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, (SQLCHAR *) odbc_sqlstate,
-		      NULL, (SQLCHAR *) odbc_err, sizeof(odbc_err), NULL, "SI");
-	printf("Message: '%s' %s\n", odbc_sqlstate, odbc_err);
-}
-
 static void
 test_err(const char *data, int c_type, const char *state)
 {
diff --git a/src/odbc/unittests/paramcore.c b/src/odbc/unittests/paramcore.c
index b179b1a..e23db83 100644
--- a/src/odbc/unittests/paramcore.c
+++ b/src/odbc/unittests/paramcore.c
@@ -4,28 +4,12 @@
  * Try to make core dump using SQLBindParameter
  */
 
-static char software_version[] = "$Id: paramcore.c,v 1.6 2008/11/04 14:46:17 freddy77 Exp $";
+static char software_version[] = "$Id: paramcore.c,v 1.7 2010/03/02 15:07:00 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define SP_TEXT "{call sp_paramcore_test(?)}"
 #define OUTSTRING_LEN 20
 
-static char MessageText[1000];
-static SQLSMALLINT TextLength;
-static SQLCHAR SqlState[6];
-
-
-static void
-ReadError(void)
-{
-	if (SQL_SUCCEEDED(SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, SqlState, NULL, (SQLCHAR*) MessageText, sizeof(MessageText), &TextLength))) {
-		SqlState[sizeof(SqlState) - 1] = 0;
-		fprintf(stderr, "State %s Message: %s\n", SqlState, MessageText);
-	}
-}
-
-
-
 int
 main(int argc, char *argv[])
 {
@@ -39,21 +23,17 @@ main(int argc, char *argv[])
 	Command("create proc sp_paramcore_test @s varchar(100) output as select @s = '12345'");
 
 	/* here we pass a NULL buffer for input SQL_NTS */
-	SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, OUTSTRING_LEN, 0, NULL, OUTSTRING_LEN, &cb);
-	ReadError();
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, OUTSTRING_LEN, 0, NULL, OUTSTRING_LEN, &cb, "S");
 
 	cb = SQL_NTS;
-	CommandWithResult(Statement, SP_TEXT);
-	ReadError();
+	CHKExecDirect((SQLCHAR*) SP_TEXT, SQL_NTS, "E");
 	ResetStatement();
 
 	/* here we pass a NULL buffer for input */
-	SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_VARCHAR, 18, 0, NULL, OUTSTRING_LEN, &cb);
-	ReadError();
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_VARCHAR, 18, 0, NULL, OUTSTRING_LEN, &cb, "S");
 
 	cb = 1;
-	CommandWithResult(Statement, SP_TEXT);
-	ReadError();
+	CHKExecDirect((SQLCHAR*) SP_TEXT, SQL_NTS, "E");
 	ResetStatement();
 
 	Command("drop proc sp_paramcore_test");
diff --git a/src/odbc/unittests/print.c b/src/odbc/unittests/print.c
index 9deb9c8..4702db7 100644
--- a/src/odbc/unittests/print.c
+++ b/src/odbc/unittests/print.c
@@ -1,10 +1,9 @@
 #include "common.h"
 
-static char software_version[] = "$Id: print.c,v 1.22 2008/12/03 12:55:52 freddy77 Exp $";
+static char software_version[] = "$Id: print.c,v 1.23 2010/03/02 15:07:00 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static SQLCHAR output[256];
-static void ReadError(void);
 
 #ifdef TDS_NO_DM
 static const int tds_no_dm = 1;
@@ -12,13 +11,6 @@ static const int tds_no_dm = 1;
 static const int tds_no_dm = 0;
 #endif
 
-static void
-ReadError(void)
-{
-	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, NULL, NULL, output, sizeof(output), NULL, "SI");
-	printf("Message: %s\n", output);
-}
-
 static int
 test(int odbc3)
 {
@@ -34,11 +26,11 @@ test(int odbc3)
 	query = "print 'START' select count(*) from sysobjects where name='sysobjects' print 'END'";
 	Command2(query, "I");
 	ReadError();
-	if (!strstr((char *) output, "START")) {
+	if (!strstr(odbc_err, "START")) {
 		printf("Message invalid\n");
 		return 1;
 	}
-	output[0] = 0;
+	odbc_err[0] = 0;
 
 	if (odbc3) {
 		CHECK_COLS(0);
@@ -71,13 +63,12 @@ test(int odbc3)
 	 * (unixODBC till 2.2.11 do not read errors on NO DATA, skip test)
 	 */
 	if (tds_no_dm || odbc3) {
-		output[0] = 0;
 		ReadError();
-		if (!strstr((char *) output, "END")) {
+		if (!strstr(odbc_err, "END")) {
 			printf("Message invalid\n");
 			return 1;
 		}
-		output[0] = 0;
+		odbc_err[0] = 0;
 	}
 
 	if (!odbc3) {
diff --git a/src/odbc/unittests/rowset.c b/src/odbc/unittests/rowset.c
index 215fbe0..aec052e 100644
--- a/src/odbc/unittests/rowset.c
+++ b/src/odbc/unittests/rowset.c
@@ -1,20 +1,8 @@
 #include "common.h"
 
-static char software_version[] = "$Id: rowset.c,v 1.5 2008/11/04 14:46:18 freddy77 Exp $";
+static char software_version[] = "$Id: rowset.c,v 1.6 2010/03/02 15:07:00 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-static char odbc_err[256];
-static char odbc_sqlstate[6];
-
-static void
-ReadError(void)
-{
-	memset(odbc_err, 0, sizeof(odbc_err));
-	memset(odbc_sqlstate, 0, sizeof(odbc_sqlstate));
-	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, (SQLCHAR *) odbc_sqlstate, NULL, (SQLCHAR *) odbc_err, sizeof(odbc_err), NULL, "SI");
-	printf("Message: '%s' %s\n", odbc_sqlstate, odbc_err);
-}
-
 static void
 test_err(int n)
 {
diff --git a/src/odbc/unittests/transaction2.c b/src/odbc/unittests/transaction2.c
index b297b1a..a59b7d7 100644
--- a/src/odbc/unittests/transaction2.c
+++ b/src/odbc/unittests/transaction2.c
@@ -3,14 +3,11 @@
 
 /* Test transaction types */
 
-static char software_version[] = "$Id: transaction2.c,v 1.8 2008/12/03 12:55:52 freddy77 Exp $";
+static char software_version[] = "$Id: transaction2.c,v 1.9 2010/03/02 15:07:00 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-static char odbc_err[256];
-static char odbc_sqlstate[6];
-
 static void
-ReadError(void)
+ReadErrorConn(void)
 {
 	memset(odbc_err, 0, sizeof(odbc_err));
 	memset(odbc_sqlstate, 0, sizeof(odbc_sqlstate));
@@ -203,7 +200,7 @@ main(int argc, char *argv[])
 
 	/* Invalid argument value */
 	CHKSetConnectAttr(SQL_ATTR_TXN_ISOLATION, int2ptr(SQL_TXN_REPEATABLE_READ | SQL_TXN_READ_COMMITTED), 0, "E");
-	ReadError();
+	ReadErrorConn();
 	if (strcmp(odbc_sqlstate, "HY024") != 0) {
 		Disconnect();
 		fprintf(stderr, "Unexpected success\n");
@@ -222,7 +219,7 @@ main(int argc, char *argv[])
 #ifdef ENABLE_DEVELOPING
 	/* test setting with active transaction "Operation invalid at this time" */
 	CHKSetConnectAttr(SQL_ATTR_TXN_ISOLATION, int2ptr(SQL_TXN_REPEATABLE_READ), 0, "E");
-	ReadError();
+	ReadErrorConn();
 	if (strcmp(odbc_sqlstate, "HY011") != 0) {
 		Disconnect();
 		fprintf(stderr, "Unexpected success\n");
@@ -236,7 +233,7 @@ main(int argc, char *argv[])
 
 	/* test setting with pending data */
 	CHKSetConnectAttr(SQL_ATTR_TXN_ISOLATION, int2ptr(SQL_TXN_REPEATABLE_READ), 0, "E");
-	ReadError();
+	ReadErrorConn();
 	if (strcmp(odbc_sqlstate, "HY011") != 0) {
 		Disconnect();
 		fprintf(stderr, "Unexpected success\n");

